/*
 * Copyright 2012 Francesco Cappelli
 *
 * This file is part of Pagliaio.
 *
 * Pagliaio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Pagliaio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Pagliaio.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef UPDATEACTION_H_
#define UPDATEACTION_H_

#include "Action.h"
#include <httpIterator.h>
#include <lucene++/LuceneHeaders.h>

namespace pagliaio {

class UpdateAction: public pagliaio::Action {
private:
	void parseAndIndexElement(Lucene::DocumentPtr luceneDoc, xmlDocPtr incomingDoc, xmlNodePtr node);

public:
	UpdateAction();
	virtual ~UpdateAction();

	std::string generateResponse(void *cls, struct MHD_Connection *connection,
								 const char *url,
								 const char *method, const char *version,
								 const char *upload_data,
								 size_t *upload_data_size, void **con_cls);
};

}

#endif /* UPDATEACTION_H_ */
